%ext ck1

# The title bitmap will be shown at offset 0,0 
%patch $97B2   $00 $00     # Y location, in pixels 
%patch $97B6   $04 $00     # (X location in pixels) / 8 + 4 

#Keen always has a pogo
%patch $900E  $01 $00 

#Nullify fallingsound
%patch $3AA5  $90 $90 

#God Cheat Code-HJS
%patch 0x0120D 0x504F
%patch 0x01214 0x5050
%patch 0x0121B 0x504B
#CTSpace Cheat Code-LEV
%patch 0x011F5 0x5052
%patch 0x011FC 0x503E
%patch 0x01203 0x505B

#God mode
%patch 0x014EF6 "Invincibility!!!"
%patch 0x014F07 "Vincibility...   "

#CTSpace
%patch 0x014DEE "You are now cheating!"
%patch 0x014E05 "You just got all of the   "
%patch 0x014E21 "key cards, and tons of"
%patch 0x014E39 "ray gun charges!        "

#This is the color palette: 16 entries of r, g, b (each 0-63)
%patch $13054 
       00 00 00  
       00 00 42 
       00 42 00  
       21 42 63 
       42 00 00 
       42 10 42 
       42 42 00 
       42 42 42 
       21 21 21 
       21 21 63 
       21 63 21 
       21 63 63 
       63 21 21  
       63 21 63 
       63 63 21 
       63 63 63 

#Set the pelette when we go into graphics mode
%patch $6E46  $E8 $D3 $D5 $90 $90 

#Code to set graphics mode and set the palette
%patch $441C                  $B8 $0D $00 $CD 
              $10 $B8 $12 $10 $B9 $08 $00 $BB 
              $00 $00 $8C $DA $8E $C2 $BA $04 
              $00 $CD $10 $BB $18 $00 $BA $1C 
              $00 $CD $10 $C3 

#Include this part if the "Change backround tiles" patch is not used
#It gives us 36 spare bytes for the palette-setting code
%patch $4409      $B8 $14 $01 $26 $81 $3F $31 
              $01 $73 $03 $B8 $8F $00 $26 $89 
              $07 $E9 $5C $01 

#Tiles
%patchfile 0x130F8 tli.tli


#######
#OPTIONAL PATCHES BY LL
#######

#Number of tiles block falls
%patch $24E8 $0A
#Location of block left end from chain
%patch $238D $02 $00
#Location of middle of block END from chain, number used =
#$FF $FF MINUS [blocks wanted - 5] here FD = FF - [8 - 5]
%patch $23F4 $03 $00
#Location of block right end, from chain, use $FF $FD for -ve values
%patch $2476 $04 $00


# Strength of vorticon commander (1 less than # shots)       
%patch $1819  $03 $00

# Change the time that the two previews take 
# Time value is in 64ths of a second (approx) 
# $012C = 300 = ~4.6 seconds 
%patch $96F2  $2A $01 
%patch $9713  $02 $00

#About Id Goes to high scores
%patch $9593  $EB $AD
#Make  high scores have no effect
%patch $9596  $EB $AD
#Make  Ordering info  have no effect.
%patch $95A3  $EB $AD

#Menu text
%patch 0x015F12 "The Keenest"
%patch 0x015F22 "^^^^^^^^^^^"
%patch 0x015F32 "***********  "
%patch 0x015F44 "Credits  "
%patch 0x015F52 "Title Screen"

#Yorp moves faster!
%patch $18D4 $A4 $FF # [si+20] left speed
%patch $18CD $5C $00 # [si+20] right speed
%patch $19C2 $A4 $FF # [si+20] left speed
%patch $19CE $5C $00 # [si+20] right speed
%patch $1964 $A0 $00 # [si+22] yorps jump higher when this is higher
%patch $1A1C $A4 $FF # [si+20] left speed
%patch $1A14 $5C $00 # [si+20] right speed

#Number of keen at start 
%patch $9002 $02 $00

# Change the controls to: Space, shoot; Enter, status. 
#http://andy.durdin.net/keen/modding/viewtopic.php?t=433
%patch $1251  $48 
%patch $7FA3  $48 
%patch $3B23  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3C4E  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3DB9  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3DCC  $90 $90 
%patch $3E6D  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3FFC  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $40AA  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00


# Change camera to follow dead Keen to the top of the level. 
%patch $342F $51 $1B 


#Change the border colors the color values are as follows:
# $01-black $02-dark blue, $03-dark turquoise, $04-dark red
# $05-dark purple $06-light grey $38-dark grey $39-light blue
# $3A-light green $3B-light turquoise $3C-light red $3D-light purple
# $3E-light yellow $3F-white

# All these should have the same value -- this is the usual border color 
%patch $4A62   $3C #Color after killing a vorticon
%patch $6F9D   $3F #Color after killing vorticon commander
%patch $15568  $01 #Darkest fade color
%patch $15579  $38 #Medium fade color
%patch $1558A  $04 #light fade color
%patch $1559B  $04 #Normal border color

# The two colors that the border flashes when a Vorticon dies 
%patch $4A7D $3F 
%patch $4A85 $3E 

# Disable the "no-clipping" on the map with GOD mode 
%patch $A626  $EB 

#Exit tiles don't change.
%patch $412E $00

#Keen dissappears as soon as he touches the exit; pause before exiting level
%patch $41CD $90

#If Keen is shorter or the Garg is taller: 
%patch $1B8B $07

# Garg slides 
%patch $1B55 $00

#Ice cannon shoot rate
%patch $2058 $08

#Pogo gives extra Keen!
%patch $44AB  $FF $06 $C6 $AA $90 $90

# Keen does not lose ship parts on dying in their levels. 
%patch 0x4F82 $90 $90 $90 $90 $90 $90 #Joystick
%patch 0x4F8A $90 $90 $90 $90 $90 $90 #Battery
%patch 0x4F92 $90 $90 $90 $90 $90 $90 #Vacum
%patch 0x4F9A $90 $90 $90 $90 $90 $90 #everclear

#Pogo doesn't fly with Godmode
%patch $3F4E  $EB

#robot's shots kill Keen but not other enemies
%patch $48E9 $04 $00 


#End of yorp messages
%patch 0x01545F "Press ENTER:" 

#First Yorp message: [Level 2] -7 lines
%patch 0x015080 "A voice buzzes in   "
%patch 0x015096 "your head:          "
%patch 0x0150AC "                    "
%patch 0x0150C2 "Be careful, there   "
%patch 0x0150D8 "are many who would  "
%patch 0x0150EE "take joy in your    "
%patch 0x015104 "faliure, human.     "

#Second Yorp message [level 6] -7 lines
%patch 0x01511A "A message echoes in "
%patch 0x015130 "your head:          "
%patch 0x015146 "                    "
%patch 0x01515C "You are doing good  "
%patch 0x015172 "so far, don't forget"
%patch 0x015188 "to save your game,  "
%patch 0x01519E "press F5 on the map."

#Third Yorp message: [level 9] -7 lines
%patch 0x0151B4 "The cold dead statue"
%patch 0x0151CA "speaks to your mind:"
%patch 0x0151E0 "                    "
%patch 0x0151F6 "This is the night   "
%patch 0x01520C "side; things are far"
%patch 0x015222 "more dangerous now  "
%patch 0x015238 "that the sun has set"

#Fourth Yorp message: [Level 10] -7 lines
%patch 0x01524E "These mental words  "
%patch 0x015264 "crystalize:         "
%patch 0x01527A "                    "
%patch 0x015290 "There is a shortcut "
%patch 0x0152A6 "through the stone   "
%patch 0x0152BC "palace, be bold and "
%patch 0x0152D2 "learn to swim!      "

#Fifth Yorp Message: [level 12] -7 lines
%patch 0x015340 "A thought not yours "
%patch 0x015356 "whispers quietly:   "
%patch 0x01536C "                    "
%patch 0x015382 "You are nearing the  " #1 longer than usual!
%patch 0x015399 "end of your quest;  "
%patch 0x0153AF "beware the red tower"
%patch 0x0153C5 "it is death!        "

#Sixth Yorp message: [level 15] -6 lines
%patch 0x0153DB "A Yorpy mind-thought"
%patch 0x0153F1 "bellows:            "
%patch 0x015407 "                    "
%patch 0x01541D "Hmmm, you survived. "
%patch 0x015433 "Perhaps you are more"
%patch 0x015449 "agile than thought. "

#Garg message: [level 11] -4 lines
%patch 0x0152E8 "A mental voice yells"
%patch 0x0152FE "                    "
%patch 0x015314 "Vermin! I will kill "
%patch 0x01532A " you!               "

#About ID text
%patch 0x015F80 "We are a group of software artists"
%patch 0x015FA8 "whose goal is to bring commercial"
%patch 0x015FD0 "quality software to the public"
%patch 0x015FF8 "at shareware prices."
%patch 0x016020 "Our effort is only possible with"
%patch 0x016048 "your support. Without it, we cannot"
%patch 0x016070 "continue to make this fine"
%patch 0x016098 "software so affordable."
%patch 0x0160C0 "Thank you in advance for your"
%patch 0x0160E8 "contribution to the future of the"
%patch 0x016110 "growing shareware market."

#Ordering Info text
%patch 0x01632C "Commander Keen: Invasion"
%patch 0x016346 "of the Vorticons consists"
%patch 0x016364 "of three unique and"
%patch 0x01637B "challenging episodes:"
%patch 0x016392 "1. Marooned on Mars   $15"
%patch 0x0163AD "2. The Earth Explodes $15"
%patch 0x0163C8 "3. Keen Must Die!     $15"
%patch 0x0163E4 "Order the trilogy for $30 and you get"
%patch 0x01640D "* The 'Secret Hints & Tricks' sheet"
%patch 0x016434 "* The special 'cheat mode' password"
%patch 0x01645B "* The latest version of each game"
%patch 0x016480 "* SEVERAL FREE BONUS GAMES!"
%patch 0x0164B5 "Mail orders to:"
%patch 0x0164DD "Apogee Software"
%patch 0x016505 "P.O. Box 476389"
%patch 0x01652D "Garland, TX 75047"
%patch 0x01646C "(U.S. funds only"
%patch 0x0164EE "checks or M/O's"
%patch 0x016516 "include $2 P&H)"
%patch 0x016542 "Specify 5.25/3.5 disk size when ordering"
%patch 0x016573 "Or order toll free: 1-800-852-5659"


#Finale:

#First we simplify it a bit:

#Skip the flight to Earth sequence. [To be cont... shown on background of
#tile No 1] Also skips Mars map and text.
%patch $81A3 $02
#Stop 3rd textbox appearing
%patch $8635 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90
#Stop 4th textbox appearing
%patch $867B $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90
#Stop 5th textbox appearing
%patch $86AF $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
#Stop 6th textbox appearing
%patch $86EC $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90
#Stop 7th textbox appearing
%patch $8714 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90

#Then we fiddle the text:

#First dialogue box at home
%patch 0x015CBD "In the Quadroid ship a"
%patch 0x015CD5 "mysterious being  "
%patch 0x015CE9 "watches Keen.    "

#Second
%patch 0x015CFB "Hmmm, next time I  "
%patch 0x015D10 "will be more subtle"
%patch 0x015D25 "Mr Blaze. "

#Eighth
%patch 0x015E07 "But for Keen his work"
%patch 0x015E1E "is done, now he can go "
%patch 0x015E37 "home and get a good"
%patch 0x015E4C "nights sleep and a   "
%patch 0x015E63 "good days play"

#Finaly [sic] we rearrange a few windows and sprites:
#Pause between exiting and ending sequence [teh black screen]
%patch $820D $2C $00
#Second textbox bottom
%patch $85D5 $18 $00
#Second Keens house textbox right side
%patch $85D9 $1D $00
#Length textbox appears [AFTER text stops writing!]
%patch $8606 $2C $00
#First Keens house textbox bottom
%patch $8546 $18 $00
#First Keens house textbox right side
%patch $854A $1D $00
#Length textbox appears [AFTER text stops writing!]
%patch $857A $2C $00
#Eighth textbox bottom
%patch $877C $18 $00
#Length textbox appears [AFTER text stops writing!]
%patch $87C8 $2C $00

%end